//+------------------------------------------------------------------+
//|                                              .mqh |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <PRNG_UD.mqh>                                           |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Pseudorandom number generator uniform distribution, PRNG_UD      |
//+------------------------------------------------------------------+
//   ,   10,  10      0-9
//   ,   100,  100      0-99
//   ,   23,  23      0-23
class C_PRNG_UD
  {
   short             cnt_rand;
   int               centr;
   int               indx;
   double            res;
   int               res_arr[];
   int               size;
   int               cnt_res;
   //---
   int               m_basis;
   uint              m_srand_init;
   bool              m_avto_srand;
   bool              m_mode_centr;
   //---
   int               Rand(double basis=32768.,uint srand_init=0,bool avto_srand=true,bool mode_centr=false)
     {
      if(cnt_rand>=32766){ if(avto_srand)SrandAvto(rand()); else Srand(rand()); } cnt_rand++;

      res=0;
      if(basis>32768.) res=Rand(basis/32768.,mode_centr);
      res+=(rand()-centr)*(basis/32768.);
      return((int)res);
     }
   void              SrandAvto(uint start=0){srand((uint)TimeLocal()*(uint)GetMicrosecondCount()*(start+1)); cnt_rand=0;}
   void              Srand(uint start=0){ srand(start+1); cnt_rand=0;}
public:
                     C_PRNG_UD(void){cnt_rand=16384.; size=0; cnt_res=0;};
                    ~C_PRNG_UD(void){};
   void              Init_Rand_Basis(int basis=32768,uint srand_init=0,bool avto_srand=true,bool mode_centr=false)
     {
      m_basis=basis;
      m_srand_init=srand_init;
      m_avto_srand=avto_srand;
      m_mode_centr=mode_centr;
      //---
      if(avto_srand)SrandAvto(srand_init); else Srand(srand_init);
      cnt_res=0;
      size=ArrayResize(res_arr,basis);
      int bas_arr[]; ArrayResize(bas_arr,basis);
      if(mode_centr) centr=16384.; else centr=0;
      //---
      for(int i=0;i<basis;i++)
         bas_arr[i]=i;
      int temp_basis=basis;
      //---
      for(int i=0;i<basis;i++)
        {
         indx=Rand(temp_basis,srand_init,avto_srand,mode_centr);
         res_arr[i]=bas_arr[indx];
         temp_basis--;
         for(int j=indx;j<temp_basis;j++)
            bas_arr[j]=bas_arr[j+1];
        }
     }
   int               GetRes(uint ind){if((int)ind<size)return(res_arr[ind]);else return(-1);};
   int               GetNext()
     {
      cnt_res++;
      if(cnt_res-1<size)
         return(res_arr[cnt_res-1]);
      else
        {
         Init_Rand_Basis(m_basis,rand(),m_avto_srand,m_mode_centr);
         cnt_res++;
         return(GetRes(0));
        }
     };
  };
//+------------------------------------------------------------------+
