//+------------------------------------------------------------------+
//|                                               SOM_Net_Player.mqh |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| #include <SOM_Net_Player.mqh>                                    |
//+------------------------------------------------------------------+
#include "SOM_Net_Img.mqh"
#include "IncGUI_v3.mqh"
//+------------------------------------------------------------------+
//|    bmp                                      |
//+------------------------------------------------------------------+
class CResource
  {
   string            m_name;// 
   string            m_path;//   
public:
                     CResource(void){};
                    ~CResource(void){};
   void              Init(string p_name,string p_path){ m_name=p_name; m_path=p_path; };
   bool              Create(){ return(ResourceCreate(m_name,m_path)); };
   bool              Create(const uint &data[],uint width,uint height){ return(ResourceCreate(m_name,data,width,height,0,0,0,COLOR_FORMAT_ARGB_NORMALIZE)); };
   bool              Free(){ return(ResourceFree(R_Name())); };
   bool              ReadImage(uint &data[],uint &width,uint &height){return(ResourceReadImage(R_Name(),data,width,height));};
   bool              Save(const string  file_name){return(ResourceSave(R_Name(),file_name));};
   string            Name(){ return(m_name); };
   string            R_Name(){ return("::"+m_name); };
   string            Paht(){ return(m_path); };
  };
//+------------------------------------------------------------------+
//|         bmp   |
//+------------------------------------------------------------------+
class CBitmapLabel
  {
protected:
   int               m_Left;//  x
   int               m_Top;//  y
   int               m_Width;//  x
   int               m_Height;//  y
   CResource         Q[];// 
   string            m_Name,m_path_bmp[];//     
   int               q_count;// 
   bool              state;// 
public:
                     CBitmapLabel(void){q_count=2; state=1; ArrayResize(Q,q_count);ArrayResize(m_path_bmp,q_count);};
                    ~CBitmapLabel(void){};
   //---                    
   void              Init(string aName,int aLeft,int aTop,int aWidth,int aHeight,string path_bmp0,string path_bmp1)
     {
      //---     
      m_Name=aName;
      m_Left=aLeft;
      m_Top=aTop;
      m_Width=aWidth;
      m_Height=aHeight;
      m_path_bmp[0]=path_bmp0;
      m_path_bmp[1]=path_bmp1;
      //---  
      for(int i=0;i<q_count;i++)
        {
         Q[i].Init(aName+".Q"+(string)i,m_path_bmp[i]);
         ResetLastError(); if(!Q[i].Create()) Print("Error creating a resource ",GetLastError());
        }
     };
   //---   
   void              Show(bool p_state=true)
     {
      //---   OBJ_BITMAP_LABEL,    
      if(ObjectFind(0,m_Name+".label")<0)
        {
         //---    OBJ_BITMAP_LABEL
         bool created=ObjectCreate(0,m_Name+".label",OBJ_BITMAP_LABEL,0,0,0);
         if(created)
           {
            //---       
            ObjectSetInteger(0,m_Name+".label",OBJPROP_CORNER,CORNER_LEFT_UPPER);
            ObjectSetInteger(0,m_Name+".label",OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
            //---    
            ObjectSetInteger(0,m_Name+".label",OBJPROP_XDISTANCE,m_Left);
            ObjectSetInteger(0,m_Name+".label",OBJPROP_YDISTANCE,m_Top);
            ObjectSetInteger(0,m_Name+".label",OBJPROP_STATE,p_state);
            //---      0
            ResetLastError();
            //---      ""
            bool set=ObjectSetString(0,m_Name+".label",OBJPROP_BMPFILE,0,Q[0].R_Name());
            //---  
            if(!set)
              {
               PrintFormat("      %s.   %d",Q[0].Name(),GetLastError());
              }
            ResetLastError();
            //---      ""
            set=ObjectSetString(0,m_Name+".label",OBJPROP_BMPFILE,1,Q[1].R_Name());
            //---
            if(!set)
              {
               PrintFormat("      %s.   %d",Q[1].Name(),GetLastError());
              }
            //---     ,     ,   
            ChartRedraw(0);
           }
         else
           {
            //---    ,   
            PrintFormat("    OBJ_BITMAP_LABEL.   %d",GetLastError());
           }
        }
     };
   //---    
   void              Hide()
     {
      //---     
      ObjectDelete(0,m_Name+".label");
      for(int i=0;i<q_count;i++) Q[i].Free();
     };
   //---      
   int               Event(const int id,
                           const long &lparam,
                           const double &dparam,
                           const string &sparam)
     {
      int m_event=0;
      if(id==CHARTEVENT_OBJECT_CLICK && sparam==m_Name+".label")
        {
         m_event=1;
         state=(bool)ObjectGetInteger(0,m_Name+".label",OBJPROP_STATE);
        }
      return(m_event);
     };
   //---     
   virtual int        State(){return(state);};
   //---    
   virtual void       SetState(bool p_state){state=p_state; ObjectSetInteger(0,m_Name+".label",OBJPROP_STATE,state);};
  };
//+------------------------------------------------------------------+
//|   4- , 4-                         |
//|                  |
//+------------------------------------------------------------------+
class CBitmapLabel4 : public CBitmapLabel
  {
protected:
   int               cnt;// 
public:
                     CBitmapLabel4(void){cnt=1; q_count=4; ArrayResize(Q,q_count);ArrayResize(m_path_bmp,q_count);};
                    ~CBitmapLabel4(void){};
   //---                  
   void              Init(string aName,int aLeft,int aTop,int aWidth,int aHeight,string path_bmp0,string path_bmp1,string path_bmp2,string path_bmp3)
     {
      //---    
      m_path_bmp[2]=path_bmp2;
      m_path_bmp[3]=path_bmp3;
      //---    CBitmapLabel
      Init(aName,aLeft,aTop,aWidth,aHeight,path_bmp0,path_bmp1);
     }
   //---      
   int               Event(const int id,
                           const long &lparam,
                           const double &dparam,
                           const string &sparam)
     {
      int m_event=0;
      if(id==CHARTEVENT_OBJECT_CLICK && sparam==m_Name+".label")
        {
         state=(bool)ObjectGetInteger(0,m_Name+".label",OBJPROP_STATE);
         if(!state)
           {
            cnt++;if(cnt>=q_count)cnt=0;
            ResetLastError();
            //---      ""
            bool set=ObjectSetString(0,m_Name+".label",OBJPROP_BMPFILE,0,Q[cnt].R_Name());
            //---  
            if(!set)
              {
               PrintFormat("      %s.   %d",Q[0].Name(),GetLastError());
              }
           }
         else
           {
            cnt++;if(cnt>=q_count)cnt=0;
            ResetLastError();
            //---      ""
            bool set=ObjectSetString(0,m_Name+".label",OBJPROP_BMPFILE,1,Q[cnt].R_Name());
            //---  
            if(!set)
              {
               PrintFormat("      %s.   %d",Q[0].Name(),GetLastError());
              }
           }
         m_event=1;
        }
      return(m_event);
     };
   //---     
   virtual int         State(){if(cnt==0)return(q_count-1);else return(cnt-1);};
   //---     
   virtual void        SetState(int p_state)
     {
      //---    
      if(p_state>=q_count)p_state=q_count-1;
      if(p_state<0)p_state=0;
      //---   ,  
      while(State()!=p_state)
        {
         bool fl_state=ObjectGetInteger(0,m_Name+".label",OBJPROP_STATE);
         //---
         ObjectSetInteger(0,m_Name+".label",OBJPROP_STATE,!fl_state);
         //---
         int id=CHARTEVENT_OBJECT_CLICK;
         long lparam=0;
         double dparam=0.;
         string sparam=m_Name+".label";
         //---
         Event(id,lparam,dparam,sparam);
         //---
         if(IsStopped())break;
        }
     };
  };
//+------------------------------------------------------------------+
//|  CCheckBoxVLabel, :  ,  |
//+------------------------------------------------------------------+
class CCheckBoxVLabel : public CCheckBox
  {
protected:
   virtual void Create()
     {
      w.Canvas(m_NameBox,m_SubWindow,m_Left,m_Top,m_Width,m_Height,m_BgColor,m_CheckColor);
      string m_str=" ";
      if(m_Value)
        {
         m_str=CharToString(252);
        }
      w.Label(m_NameChecked,m_SubWindow,m_Left+1,m_Top+1,m_str,m_CheckColor,12,"Wingdings");
      w.Label(m_NameLabel,m_SubWindow,m_Left,m_Top-m_Height,m_Caption,m_LabelColor,7);
     }
public:
                     CCheckBoxVLabel(void){};
                    ~CCheckBoxVLabel(void){};
   virtual void Init(string aName="CCheckBox",string aCaption="CCheckBox")
     {
      m_NameBox=aName+"_B";
      m_NameChecked=aName+"_C";
      m_NameLabel=aName+"_L";
      m_Caption=aCaption;
      m_BgColor=ClrScheme.Color(0);
      m_CheckColor=ClrScheme.Color(1);
      m_LabelColor=clrBlack;//ClrScheme.Color(2);
      m_Value=false;
      m_Visible=false;
      m_Width=15;
      m_Height=15;
      m_SubWindow=0;
      m_Tag="";
     }
  };
//+------------------------------------------------------------------+
//|  CSpinInputBox, :  ,    |
//+------------------------------------------------------------------+
class CSpinInputBoxVLabel : public CSpinInputBox
  {
   virtual void Create()
     {
      w.Edit(m_NameSD,m_SubWindow,m_Left+m_Width-13,m_Top+7,13,8," -",m_SpBgColor,m_SpTxtColor,6,"Arial");
      w.Edit(m_NameSU,m_SubWindow,m_Left+m_Width-13,m_Top,13,8," +",m_SpBgColor,m_SpTxtColor,5,"Arial");
      g.SetReadOnly(m_NameSU,true);
      g.SetReadOnly(m_NameSD,true);
      if(m_Caption!="")
        { //  
         w.Label(m_NameLabel,m_SubWindow,m_Left,m_Top-m_Height,m_Caption,m_LblColor,7,"Arial"); //  
        }
     }
public:
                     CSpinInputBoxVLabel(void){};
                    ~CSpinInputBoxVLabel(void){};
   virtual void Init(string aName="CSpinInputBox",int aWidth=50,double aChange=0.1,string aCaption="CSpinInputBox")
     {
      m_NameSU=aName+"_U";
      m_NameSD=aName+"_D";
      m_NameLabel=aName+"_L";
      m_SubWindow=0;
      m_Left=0;
      m_Top=0;
      m_Width=aWidth;
      m_Height=15;
      m_Caption=aCaption;
      m_SpTxtColor=ClrScheme.Color(1); //    ,      
      m_LblColor=clrBlack;//ClrScheme.Color(2);   //                 
      m_WrongColor=ClrScheme.Color(3); //      
      m_SpBgColor=ClrScheme.Color(4);  //  , 
      m_FlashColor=ClrScheme.Color(5); //  , 
      m_Visible=false;
      m_Change=aChange;
      m_Digits=DefineDigits(m_Change);
      m_ib.Init(aName+"_IB",m_Width-12,m_Digits,""); //   
      m_ib.SetReadOnly(true);
     }
  };
//+------------------------------------------------------------------+
//|  CInputBox, :  ,        |
//+------------------------------------------------------------------+
class CInputBoxVLabel : public CInputBox
  {
   virtual void Create()
     {    //    
      color m_ctmp=m_BgColor; //   
      if(m_Warning)
        { //   
         m_ctmp=m_WarningColor; //      
        }
      w.Edit(m_NameEdit,m_SubWindow,m_Left,m_Top,m_Width,m_Height,m_Value,m_ctmp,m_TxtColor,7,"Arial"); //   
      g.SetReadOnly(m_NameEdit,m_ReadOnly);
      if(m_Caption!="")
        { //  
         w.Label(m_NameLabel,m_SubWindow,m_Left,m_Top-m_Height,m_Caption,m_LblColor,7,"Arial"); //  
        }
     }
public:
                     CInputBoxVLabel(void){};
                    ~CInputBoxVLabel(void){};
   virtual void Init(string aName="CInputBox",int aWidth=50,int aDigits=-1,string aCaption="CInputBox")
     { //  
      m_NameEdit=aName+"_E"; //    
      m_NameLabel=aName+"_L"; //   
      m_Left=0; //  
      m_Top=0; //  Y
      m_Width=aWidth; // 
      m_Height=15; // 
      m_Visible=false; // 
      m_Digits=aDigits; //        
      m_Caption=aCaption; //  
      m_Value=""; //    
      if(aDigits>=0)m_Value=DoubleToString(0,m_Digits); //    
      m_ValueMin=-DBL_MAX; //  
      m_ValueMax=DBL_MAX; //  
      m_BgColor=ClrScheme.Color(0); //    
      m_TxtColor=ClrScheme.Color(1); //      
      m_LblColor=clrBlack;//ClrScheme.Color(2); //  
      m_WarningColor=ClrScheme.Color(3); //  
      m_Warning=false; // : , 
      m_SubWindow=0; //  
      m_Tag=""; // 
     }
  };
//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
class SOM_Net_Player : public CSOM_Net_Img
  {
protected:
   int               m_Left;//   x
   int               m_Top;//   y
   int               m_Width_w;//     x
   int               m_Height_w;//     y
   int               m_Width_h;//     x
   int               m_Height_h;//     y   
   string            m_Name;// 
   //---     
   CFrame            fmame_w,fmame_h;//,  
   CWorkPiece        fmame_x;//   ,   
   //---  
   //--- 
   CBitmapLabel      Lerning_Button;///
   CBitmapLabel      Start_Button;///   
   CBitmapLabel4     Pikch_Button;// 
   CBitmapLabel      Bordur_Button;// , /
   CBitmapLabel      Hexagonal_Button;// , /
   //--- 
   CCheckBoxVLabel   checkBmp;// bmp , /
   CCheckBoxVLabel   checkTitles;//    , /
   //---   
   CSpinInputBoxVLabel maxPikch_line;// bmp  
   CSpinInputBoxVLabel splinEditX_bmp;// bmp  
   CSpinInputBoxVLabel splinEditY_bmp;// bmp  y 
   //---    
   //---   
   CInputBoxVLabel   editPattern;//     
   CInputBoxVLabel   editNet;//  /  .somnet
   //---   
   CSpinInputBoxVLabel splinIter;//  
   CSpinInputBoxVLabel splinX;//   x
   CSpinInputBoxVLabel splinY;//   y
   //---  
   CHProgress        progress;
   //---
   int               ShowPattern(double &vector[],string name_title);
   int               index;
public:
                     SOM_Net_Player(void){};
                    ~SOM_Net_Player(void){};
   void              Progress(int p_iter);
   //---   
   void              Init(string aName="Player",int aLeft=10,int aTop=30,int aWidth=50,int aHeight=50,int bWidth=50,int bHeight=50);
   //---   
   void              Show();
   //---     (  )
   void              Hide();
   //---      
   void              Event(const int id,
                           const long &lparam,
                           const double &dparam,
                           const string &sparam);
  };
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void SOM_Net_Player::Init(string aName="Player",int aLeft=10,int aTop=30,int aWidth=50,int aHeight=50,int bWidth=50,int bHeight=50)
  {
   m_ShiftBmpW=aLeft+bWidth+5;
   m_ShiftBmpH=aTop+aHeight+5;
   m_Name=aName;
   m_Left=aLeft;
   m_Top=aTop;
   m_Width_w=aWidth;
   m_Height_w=aHeight;
   m_Width_h=bWidth;
   m_Height_h=bHeight;
//---
   fmame_w.Init(m_Name+".w",m_Width_w,m_Height_w,"");
   fmame_w.SetPos(m_Left,m_Top);
   fmame_h.Init(m_Name+".h",m_Width_h,m_Height_h,"");
   fmame_h.SetPos(m_Left,m_Top);
//---
   int ShiftW=10,ShiftW_Button=3,ShiftH=65,Shift_SplinEdit=40,Shift_Button=155;
//---
   checkBmp.Init(m_Name+"checkboxBmp","Save bmp");
   checkBmp.SetPos(m_Left+ShiftW,m_Top+ShiftH);
//---
   checkTitles.Init(m_Name+"checkboxTitles","Show title");
   checkTitles.SetPos(m_Left+ShiftW,m_Top+ShiftH+40);
//---
   maxPikch_line.Init(m_Name+"maxPikch",40,1,"Max line");
   maxPikch_line.SetPos(m_Left+ShiftW,m_Top+ShiftH+Shift_SplinEdit+40);
   maxPikch_line.SetReadOnly(false);
//---
   splinEditX_bmp.Init(m_Name+"editXbmp",40,1,"X bmp");
   splinEditX_bmp.SetPos(m_Left+ShiftW,m_Top+ShiftH+Shift_SplinEdit+80);
   splinEditX_bmp.SetReadOnly(false);
//---
   splinEditY_bmp.Init(m_Name+"editYbmp",40,1,"Y bmp");
   splinEditY_bmp.SetPos(m_Left+ShiftW,m_Top+ShiftH+Shift_SplinEdit+120);
   splinEditY_bmp.SetReadOnly(false);
//---
   Lerning_Button.Init("Lerning_Button",m_Left+ShiftW+ShiftW_Button,m_Top+10,30,29,
                       "\\Images\\SOM\\Work_G30x29_alpha.bmp",
                       "\\Images\\SOM\\Work_Q30x29_alpha.bmp");
   Start_Button.Init("Start_Button",m_Left+ShiftW+42,m_Top+10,30,29,
                     "\\Images\\SOM\\Start_Q30x29_alpha.bmp",
                     "\\Images\\SOM\\Start_G30x29_alpha.bmp");
   Pikch_Button.Init("Pikch_Button",m_Left+ShiftW+ShiftW_Button,m_Top+ShiftH+Shift_SplinEdit+Shift_Button+0,30,29,
                     "\\Images\\SOM\\Pikch_Q30x29.bmp",
                     "\\Images\\SOM\\Pikch_QQ30x29.bmp",
                     "\\Images\\SOM\\Pikch_GG30x29.bmp",
                     "\\Images\\SOM\\Pikch_G30x29.bmp");
   Bordur_Button.Init("Bordur_Button",m_Left+1+ShiftW+ShiftW_Button,m_Top+ShiftH+Shift_SplinEdit+Shift_Button+40,28,29,
                      "\\Images\\SOM\\Bordur_Q30x29.bmp",
                      "\\Images\\SOM\\Bordur_G30x29.bmp");
   Hexagonal_Button.Init("Hexagonal_Button",m_Left+1+ShiftW+ShiftW_Button,m_Top+ShiftH+Shift_SplinEdit+Shift_Button+80,30,29,
                         "\\Images\\SOM\\Hexagonal_G30x29_alpha.bmp",
                         "\\Images\\SOM\\Hexagonal_Q30x29_alpha.bmp");
//---
   int ShiftWW=70,ShiftWWPatt=190,WidthEditNum=40,WidthEditPatt=150;
   editPattern.Init("editPattern",WidthEditPatt,-1,"File Patterns");
   editPattern.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW+ShiftWWPatt,m_Top+20);
   editPattern.SetReadOnly(false);
   editNet.Init("editNet",WidthEditPatt,-1,"File SOM Net");
   editNet.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW+WidthEditPatt+10+ShiftWWPatt,m_Top+20);
   editNet.SetReadOnly(false);
//---
   splinIter.Init(m_Name+"splinIter",WidthEditNum+20,1,"Iteration");
   splinIter.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW,m_Top+20);
   splinIter.SetReadOnly(false);
//---
   splinX.Init(m_Name+"splinX",WidthEditNum,1,"X nodes");
   splinX.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW+(10+WidthEditNum)+20,m_Top+20);
   splinX.SetReadOnly(false);
//---
   splinY.Init(m_Name+"splinY",WidthEditNum,1,"Y nodes");
   splinY.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW+2*(10+WidthEditNum)+20,m_Top+20);
   splinY.SetReadOnly(false);
//---
   progress.Init(m_Name+"progress",500);
   progress.SetPos(m_Left+ShiftW+ShiftW_Button+ShiftWW,m_Top+40);

  };
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
void SOM_Net_Player::Show()
  {
   fmame_w.Show();
   fmame_h.Show();
   fmame_x.Frame(m_Name+".x",0,m_Left+1,m_Top+1,m_Width_w-2,m_Height_w-2,"",0,ClrScheme.Color(39),ClrScheme.Color(39));
//---
   checkBmp.SetValue(SaveFiles); checkBmp.Show();
   checkTitles.SetValue(ShowTitles); checkTitles.Show();
//---
   maxPikch_line.SetMinValue(1); maxPikch_line.SetValue(MaxPictures); maxPikch_line.Show();
   splinEditX_bmp.SetMinValue(1); splinEditX_bmp.SetValue(ImageXSize); splinEditX_bmp.Show();
   splinEditY_bmp.SetMinValue(1); splinEditY_bmp.SetValue(ImageYSize); splinEditY_bmp.Show();
//---
   editPattern.SetValue(DataFileName); editPattern.Show();
   editNet.SetValue(SOM_Net); editNet.Show();
//---
   progress.Begin(); progress.Show();
//---
   splinIter.SetMinValue(10); splinIter.SetValue(Iteration); splinIter.Show();
   splinX.SetMinValue(1); splinX.SetValue(CellsX);  splinX.Show();
   splinY.SetMinValue(1); splinY.SetValue(CellsY); splinY.Show();
//---
   Lerning_Button.Show();
   Start_Button.Show();
//---
   Pikch_Button.Show();
//---
   Hexagonal_Button.Show();
   Bordur_Button.Show();
//---
   checkBmp.SetValue(SaveFiles);
   checkTitles.SetValue(ShowTitles);
   maxPikch_line.SetValue(MaxPictures);
   splinEditX_bmp.SetValue(ImageXSize);
   splinEditY_bmp.SetValue(ImageYSize);
   splinIter.SetValue(Iteration);
   splinX.SetValue(CellsX);
   splinY.SetValue(CellsY);
   editPattern.SetValue(DataFileName);
   editNet.SetValue(SOM_Net);
   Pikch_Button.SetState(ColorScheme);
   Hexagonal_Button.SetState(HexagonalCell);
   Bordur_Button.SetState(ShowBorders);
  };
//+------------------------------------------------------------------+
//|    (  )      |
//+------------------------------------------------------------------+
void SOM_Net_Player::Hide()
  {
   fmame_x.FrameDelete(m_Name+".x");
   fmame_w.Hide();
   fmame_h.Hide();
//---
   checkBmp.Hide();
   checkTitles.Hide();
//---
   maxPikch_line.Hide();
   splinEditX_bmp.Hide();
   splinEditY_bmp.Hide();
//---
   editPattern.Hide();
   editNet.Hide();
//---
   splinIter.Hide();
   splinX.Hide();
   splinY.Hide();
//---
   progress.Hide();
//---
   Lerning_Button.Hide();
   Start_Button.Hide();
   Pikch_Button.Hide();
   Hexagonal_Button.Hide();
   Bordur_Button.Hide();
  };
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void SOM_Net_Player::Event(const int id,
                           const long &lparam,
                           const double &dparam,
                           const string &sparam)
  {
   if(!(id==CHARTEVENT_OBJECT_CLICK || id==CHARTEVENT_OBJECT_ENDEDIT || id==CHARTEVENT_CUSTOM+333))return;
//---     ,  -  ,    
   if((bool)checkBmp.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)checkTitles.Event(id,lparam,dparam,sparam)){ return;}
//---
   if((bool)maxPikch_line.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)splinEditX_bmp.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)splinEditY_bmp.Event(id,lparam,dparam,sparam)){ return;}
//---
   if((bool)splinIter.Event(id,lparam,dparam,sparam)){splinIter.Value(); return;}
   if((bool)splinX.Event(id,lparam,dparam,sparam))
     {if(splinX.Value()>splinEditX_bmp.Value())splinEditX_bmp.SetValue(splinX.Value()); Sleep(15); return;}
   if((bool)splinY.Event(id,lparam,dparam,sparam))
     {if(splinY.Value()>splinEditY_bmp.Value())splinEditY_bmp.SetValue(splinY.Value()); Sleep(15); return;}
//---
   if((bool)editPattern.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)editNet.Event(id,lparam,dparam,sparam)){ return;}
//---
   if((bool)Pikch_Button.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)Hexagonal_Button.Event(id,lparam,dparam,sparam)){ return;}
   if((bool)Bordur_Button.Event(id,lparam,dparam,sparam)){ return;}
//---
   if((bool)Lerning_Button.Event(id,lparam,dparam,sparam)){ Start_Button.SetState(true); progress.Begin(); Sleep(15); return;}
//---
   if((bool)Start_Button.Event(id,lparam,dparam,sparam) && !Start_Button.State())
     {
      if(LoadPatternDataFromFile(editPattern.ValueString()))
        {
         //---    
         InitParameters((int)NormalizeDouble(splinIter.Value(),0),(int)NormalizeDouble(splinX.Value(),0),(int)NormalizeDouble(splinY.Value(),0),
                        (int)NormalizeDouble(splinEditX_bmp.Value(),0),(int)NormalizeDouble(splinEditY_bmp.Value(),0),
                        Hexagonal_Button.State(),Bordur_Button.State(),checkTitles.Value(),Pikch_Button.State(),(int)NormalizeDouble(maxPikch_line.Value(),0));
         //---
         splinEditX_bmp.SetValue(m_xsize);
         splinEditY_bmp.SetValue(m_ysize);
         //---
         if(Lerning_Button.State())
            //---   
           { TrainInit(); time=0; res_time=0; gtc=GetTickCount(); progress.Begin(); }
         else
           {//---    
            if(DownloadNet(editNet.ValueString()))
              {
               splinX.SetValue(m_xcells);
               splinY.SetValue(m_ycells);
               splinEditX_bmp.SetValue(m_xsize);
               splinEditY_bmp.SetValue(m_ysize);
               //---
               InitParameters((int)NormalizeDouble(splinIter.Value(),0),(int)NormalizeDouble(splinX.Value(),0),(int)NormalizeDouble(splinY.Value(),0),
                              (int)NormalizeDouble(splinEditX_bmp.Value(),0),(int)NormalizeDouble(splinEditY_bmp.Value(),0),
                              Hexagonal_Button.State(),Bordur_Button.State(),checkTitles.Value(),Pikch_Button.State(),(int)NormalizeDouble(maxPikch_line.Value(),0));
               NetInit();
               Render();
               ShowBMP(false);
               ChartRedraw();
               ArrayResize(datavector,m_dimension);
               index=0;
              }
            else
              {
               Print("Expert       "+editNet.ValueString()+".somnet");
               Start_Button.SetState(!Start_Button.State());
               ChartRedraw();
              }
           }
        }
      else
        {
         Print("Expert       "+editPattern.ValueString());
         Start_Button.SetState(!Start_Button.State());
         ChartRedraw();
        }
     }
   if(Lerning_Button.State())//---  
     {
      if(!Start_Button.State())
        {//---   
         //---     
         TrainIterations(iter);
         //---      
         //---      N- 
         //if(iter%100==0) 
         if((iter*100.0/m_iterations)==(double)(iter*100/m_iterations))
           {
            Progress(iter); ChartRedraw();
/*
         //---      .
         int WIDTH=1465,HEIGHT=855,itername=(int(iter*100.0/m_iterations));
         string name="SOM\\ScreenShot\\Train SOM "+(itername<10?"0"+(string)itername:(string)itername)+".bmp";
         if(itername==100)name="SOM\\ScreenShot\\Train SOM 999.bmp";         
         ChartScreenShot(0,name,WIDTH,HEIGHT,ALIGN_LEFT);
*/
           }
         if(IsStopped() || iter>m_iterations)
           {
            //---   ,   "",  
            iter=0; Start_Button.SetState(!Start_Button.State()); ChartRedraw();
            //---    
            SaveNet(SOM_Net);
            //---  bmp
            ShowBMP(false);
            //---  true   bmp  
            if(SaveFiles)SaveBMP();
            return;
           }
         //---   ,          
         if(id==CHARTEVENT_OBJECT_CLICK || id==CHARTEVENT_CUSTOM+333)EventChartCustom(0,333,0,0.,"");
        }
     }
   else //---  
     {
      if(!Start_Button.State())
        {//---   
         //---                  
         if(index<m_total_patterns_sets)
           {
            //---  datavector     
            for(int k=0; k<m_dimension && !IsStopped(); k++)
              {
               datavector[k]=m_patterns_sets_array[m_dimension*(index)+k];
              }
            ShowPattern(datavector,m_patterns_titles[index]);
            index++;
            //---  bmp
            ShowBMP(false);
            //---   , 
            if(IsStopped())return;
           }
         else
           {
            Start_Button.SetState(!Start_Button.State());
            ChartRedraw();
            return;
           }
         //---    ,        
         if(id==CHARTEVENT_OBJECT_CLICK || id==CHARTEVENT_CUSTOM+333)EventChartCustom(0,333,0,0.,"");
        }
     }
  };
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void SOM_Net_Player::Progress(int p_iter)
  {
//---    
   progress.SetValue(int(p_iter*100.0/m_iterations));
//---      bmp
   Render(); ShowBMP(false);
//---          
   if(((int)(p_iter*100.0/m_iterations)>=100))progress.Reset();
  };
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
int SOM_Net_Player::ShowPattern(double &vector[],string name_title)
  {
   int indx=BestMatchingNode(vector);
//---   
   Print(" ",name_title,":     =",indx);
//---
   int x1,y1,x2,y2;
   m_som_nodes[indx].GetCoordinates(x1,y1,x2,y2);
//---
   int avgcolor=0;
   for(int i=0; i<m_dimension; i++)
     {
      avgcolor+=int((255*(m_som_nodes[indx].GetWeight(i)-m_min_values[i])/(m_max_values[i]-m_min_values[i])));
     }
   if(m_HexagonalCell)
     {
      //--- 
      int x_size=int (MathAbs(x2-x1));
      int y_size=int (MathAbs(y2-y1));
      y1=y1+y_size/4;
      y2=y2+y_size/4;
     }
//---
   int xc=(x1+x2)/2;
   int yc=(y1+y2)/2;
//---
   if(m_ShowTitles)
     {
      for(int i=0; i<m_dimension; i++)
        {
         if(avgcolor<=m_dimension*128)
           {
            m_bmp[i].TypeText(xc+1,yc+1,name_title,clrBlack);
            m_bmp[i].TypeText(xc,yc,name_title,clrWhite);
           }
         else
           {
            m_bmp[i].TypeText(xc+1,yc+1,name_title,clrBlack);
            m_bmp[i].TypeText(xc,yc,name_title,clrWhite);
           }
        }
     }
   return(0);
  };
//+------------------------------------------------------------------+
